Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/test/java/org/gvsig/expresionevaluator/impl/TestOptimizer.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/test/java/org/gvsig/expresionevaluator/impl/TestOptimizer.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/test/java/org/gvsig/expresionevaluator/impl/TestOptimizer.java	(revision 44198)
@@ -223,12 +223,12 @@
 
         Compiler compiler = createCompiler();
         Code code = compiler.compileExpression(source);
-        assertEquals(operatorName + "(\"precio\", 23)", code.toString());
+        assertEquals( "(\"precio\" "+operatorName+" 23)", code.toString());
 
         SymbolTable symbolTable = createSymbolTable();
         Optimizer optimizer = createOptimizer(symbolTable);
         Code code2 = optimizer.optimize(code);
-        assertEquals(operatorName + "(\"precio\", 23)", code2.toString());
+        assertEquals( "(\"precio\" "+operatorName+" 23)", code2.toString());
     }
 
     public void testOperators() {
@@ -259,12 +259,12 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
-        assertEquals("+(+(+(\"precio\", *(10, 2)), 20), 30)", code.toString());
+        assertEquals("(((\"precio\" + (10 * 2)) + 20) + 30)", code.toString());
 
         SymbolTable symbolTable = createSymbolTable();
         Optimizer optimizer = createOptimizer(symbolTable);
         Code code2 = optimizer.optimize(code);
-        assertEquals("+(+(+(\"precio\", 20), 20), 30)", code2.toString());
+        assertEquals("(((\"precio\" + 20) + 20) + 30)", code2.toString());
     }
     
     public void testMul0() {
@@ -273,12 +273,12 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
-        assertEquals("+(+(+(\"precio\", *(10, 0)), 20), 30)", code.toString());
+        assertEquals("(((\"precio\" + (10 * 0)) + 20) + 30)", code.toString());
 
         SymbolTable symbolTable = createSymbolTable();
         Optimizer optimizer = createOptimizer(symbolTable);
         Code code2 = optimizer.optimize(code);
-        assertEquals("+(+(\"precio\", 20), 30)", code2.toString());
+        assertEquals("((\"precio\" + 20) + 30)", code2.toString());
     }
 
     public void testMul1() {
@@ -287,12 +287,12 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
-        assertEquals("+(+(+(\"precio\", *(10, 1)), 20), 30)", code.toString());
+        assertEquals("(((\"precio\" + (10 * 1)) + 20) + 30)", code.toString());
 
         SymbolTable symbolTable = createSymbolTable();
         Optimizer optimizer = createOptimizer(symbolTable);
         Code code2 = optimizer.optimize(code);
-        assertEquals("+(+(+(\"precio\", 10), 20), 30)", code2.toString());
+        assertEquals("(((\"precio\" + 10) + 20) + 30)", code2.toString());
     }
 
     public void testDiv1() {
@@ -301,12 +301,12 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
-        assertEquals("+(+(+(\"precio\", /(10, 1)), 20), 30)", code.toString());
+        assertEquals("(((\"precio\" + (10 / 1)) + 20) + 30)", code.toString());
 
         SymbolTable symbolTable = createSymbolTable();
         Optimizer optimizer = createOptimizer(symbolTable);
         Code code2 = optimizer.optimize(code);
-        assertEquals("+(+(+(\"precio\", 10), 20), 30)", code2.toString());
+        assertEquals("(((\"precio\" + 10) + 20) + 30)", code2.toString());
     }
 
     public void testDiv0() {
@@ -315,12 +315,12 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
-        assertEquals("+(+(+(\"precio\", /(0, 10)), 20), 30)", code.toString());
+        assertEquals("(((\"precio\" + (0 / 10)) + 20) + 30)", code.toString());
 
         SymbolTable symbolTable = createSymbolTable();
         Optimizer optimizer = createOptimizer(symbolTable);
         Code code2 = optimizer.optimize(code);
-        assertEquals("+(+(\"precio\", 20), 30)", code2.toString());
+        assertEquals("((\"precio\" + 20) + 30)", code2.toString());
     }
 
     public void testAddMulPar() {
@@ -329,12 +329,12 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
-        assertEquals("+(+(*(+(\"precio\", 10), 2), 20), 30)", code.toString());
+        assertEquals("((((\"precio\" + 10) * 2) + 20) + 30)", code.toString());
 
         SymbolTable symbolTable = createSymbolTable();
         Optimizer optimizer = createOptimizer(symbolTable);
         Code code2 = optimizer.optimize(code);
-        assertEquals("+(+(*(+(\"precio\", 10), 2), 20), 30)", code2.toString());
+        assertEquals("((((\"precio\" + 10) * 2) + 20) + 30)", code2.toString());
     }
 
     public void testAbs() {
@@ -343,12 +343,12 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
-        assertEquals("+(\"precio\", abs(10))", code.toString());
+        assertEquals("(\"precio\" + abs(10))", code.toString());
 
         SymbolTable symbolTable = createSymbolTable();
         Optimizer optimizer = createOptimizer(symbolTable);
         Code code2 = optimizer.optimize(code);
-        assertEquals("+(\"precio\", 10)", code2.toString());
+        assertEquals("(\"precio\" + 10)", code2.toString());
     }
 
     public void testAbs2() {
@@ -357,12 +357,12 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
-        assertEquals("+(\"precio\", abs(NEGATE(10)))", code.toString());
+        assertEquals("(\"precio\" + abs(-(10)))", code.toString());
 
         SymbolTable symbolTable = createSymbolTable();
         Optimizer optimizer = createOptimizer(symbolTable);
         Code code2 = optimizer.optimize(code);
-        assertEquals("+(\"precio\", 10)", code2.toString());
+        assertEquals("(\"precio\" + 10)", code2.toString());
     }
 
     public void testPI() {
@@ -371,12 +371,12 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
-        assertEquals("+(\"precio\", PI())", code.toString());
+        assertEquals("(\"precio\" + PI())", code.toString());
 
         SymbolTable symbolTable = createSymbolTable();
         Optimizer optimizer = createOptimizer(symbolTable);
         Code code2 = optimizer.optimize(code);
-        assertEquals("+(\"precio\", 3.141592653589793)", code2.toString());
+        assertEquals("(\"precio\" + 3.141592653589793)", code2.toString());
     }
 
     public void testCeil() {
@@ -385,12 +385,12 @@
         Compiler compiler = createCompiler();
 
         Code code = compiler.compileExpression(source);
-        assertEquals("+(\"precio\", CEIL(PI()))", code.toString());
+        assertEquals("(\"precio\" + CEIL(PI()))", code.toString());
 
         SymbolTable symbolTable = createSymbolTable();
         Optimizer optimizer = createOptimizer(symbolTable);
         Code code2 = optimizer.optimize(code);
-        assertEquals("+(\"precio\", 4.0)", code2.toString());
+        assertEquals("(\"precio\" + 4.0)", code2.toString());
     }
 
     public void testConcat() {
@@ -452,7 +452,7 @@
     public void testSpatialExpression1() throws Exception {
         IProjection proj = CRSFactory.getCRS("EPSG:4326");
         ExpressionBuilder builder = new DefaultExpressionBuilder();
-        builder.getConfig().set(ExpressionBuilder.Config.geometry_type_support, ExpressionBuilder.GeometrySupportType.WKB);
+        builder.geometry_support_type(ExpressionBuilder.GeometrySupportType.WKB);
 
         String source = builder.and(
                 builder.custom(this.createExpr1()),
@@ -471,7 +471,7 @@
         Code code = compiler.compileExpression(source);
         System.out.println(code.toString());
         assertEquals(
-                "AND(>(\"campo1\", 10), ST_Intersects(ST_GeomFromWKB(DECODE('000000000300000001000000050000000000000000000000000000000000000000000000004059000000000000405900000000000040590000000000004059000000000000000000000000000000000000000000000000000000000000', 'hex'), 4326), \"GEOMETRY\"))",
+                "((\"campo1\" > 10) AND ST_Intersects(ST_GeomFromWKB(DECODE('000000000300000001000000050000000000000000000000000000000000000000000000004059000000000000405900000000000040590000000000004059000000000000000000000000000000000000000000000000000000000000', 'hex'), 4326), \"GEOMETRY\"))",
                 code.toString()
         );
 
@@ -487,7 +487,7 @@
 //        System.out.println("Tiempo de optimizacion: " + (System.currentTimeMillis() - t1));
         System.out.println(code2.toString());
         assertEquals(
-                "AND(>(\"campo1\", 10), ST_Intersects('POLYGON ((0 0, 0 100, 100 100, 100 0, 0 0))'::geometry, \"GEOMETRY\"))",
+                "((\"campo1\" > 10) AND ST_Intersects('POLYGON ((0 0, 0 100, 100 100, 100 0, 0 0))'::geometry, \"GEOMETRY\"))",
                 code2.toString()
         );
 
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/test/java/org/gvsig/expresionevaluator/impl/TestExpressionBuilder.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/test/java/org/gvsig/expresionevaluator/impl/TestExpressionBuilder.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/test/java/org/gvsig/expresionevaluator/impl/TestExpressionBuilder.java	(revision 44198)
@@ -1,15 +1,10 @@
 package org.gvsig.expresionevaluator.impl;
 
-import java.util.ArrayList;
-import java.util.List;
 import junit.framework.TestCase;
 import org.apache.commons.lang3.ArrayUtils;
 import org.cresques.cts.IProjection;
 import org.gvsig.expressionevaluator.ExpressionBuilder;
-import org.gvsig.expressionevaluator.ExpressionBuilder.Config;
 import org.gvsig.expressionevaluator.ExpressionBuilder.GeometrySupportType;
-import org.gvsig.expressionevaluator.ExpressionBuilder.Parameter;
-import org.gvsig.expressionevaluator.ExpressionBuilder.Variable;
 import org.gvsig.expressionevaluator.impl.DefaultExpressionBuilder;
 import org.gvsig.fmap.crs.CRSFactory;
 import org.gvsig.fmap.geom.Geometry;
@@ -29,7 +24,6 @@
     protected void setUp() throws Exception {
         super.setUp();
         new DefaultLibrariesInitializer().fullInitialize();
-//        new ExpressionEvaluatorImplLibrary().initialize();
     }
 
     @Override
@@ -40,45 +34,12 @@
     // TODO add test methods here. The name must begin with 'test'. For example:
     // public void testHello() {}
     
-    List<String> getVariableNames(ExpressionBuilder builder) {
-        List<String> vars = new ArrayList<>();
-        for (Variable var : builder.getVariables()) {
-            vars.add(var.getName());
-        }
-        return vars;
-    }
-    
-    List<String> getParameterNames(ExpressionBuilder builder) {
-        List<String> params = new ArrayList<>();
-        for (Parameter param : builder.getParameters()) {
-            String s;
-            switch(param.getType()) {
-                case Constant:
-                    Object value = param.getValue();
-                    if( value==null ) {
-                        s = "null";
-                    } else if( value instanceof String ) {
-                        s = "'" + (String)value + "'";
-                    } else {
-                        s = value.toString();
-                    }    
-                    break;
-                case Geometry:
-                case Variable:
-                default:
-                    s = "\"" + param.getName() + "\"";
-            }
-            params.add(s);
-        }
-        return params;
-    }
-    
     public void test2() {
         ExpressionBuilder builder = new DefaultExpressionBuilder();
         
         builder.and(
           builder.eq(
-            builder.lcase(builder.variable("colum_name_c")),
+            builder.lower(builder.variable("colum_name_c")),
             builder.parameter("colum_name_p")
           )
         );
@@ -86,7 +47,7 @@
             builder.group(
                 builder.or(
                     builder.like(
-                        builder.lcase( builder.variable("uno")),
+                        builder.lower( builder.variable("uno")),
                         builder.constant("%10")
                     ),
                     builder.lt(
@@ -114,16 +75,16 @@
             )
         );
         assertEquals(
-                "( (LCASE(\"colum_name_c\")) = (?) ) AND ( ( (LCASE(\"uno\")) LIKE ('%10') ) OR ( (\"dos\") < (-3.5) ) ) AND ST_Intersects((\"geom1\"), (ST_Envelope(ST_GeomFromWKB((?), (?))))) AND ( (\"tres\") > (123456789) )",
+                "( (LOWER(\"colum_name_c\")) = (?) ) AND ( ( (LOWER(\"uno\")) LIKE ('%10') ) OR ( (\"dos\") < (-3.5) ) ) AND ST_Intersects((\"geom1\"), (ST_Envelope(ST_GeomFromWKB((?), (?))))) AND ( (\"tres\") > (123456789) )",
                 builder.toString()
         );
         assertEquals(
                 "[colum_name_c, dos, geom1, tres, uno]",
-                ArrayUtils.toString(getVariableNames(builder))
+                ArrayUtils.toString(builder.variables_names())
         );
         assertEquals(
                 "[\"colum_name_p\", \"geom2\", 4326]",
-                ArrayUtils.toString(getParameterNames(builder))
+                ArrayUtils.toString(builder.parameters_names())
         );
     }
     
@@ -140,13 +101,13 @@
               builder.variable("the_geom")
             )
         );
-        builder.getConfig().set(Config.geometry_type_support, GeometrySupportType.WKT);
+        builder.geometry_support_type(GeometrySupportType.WKT);
         System.out.println(builder.toString());
         assertEquals(
-                "ST_Intersects((ST_GeomFromText('POINT (10 20)', (4326))), (\"the_geom\"))",
+                "ST_Intersects((ST_GeomFromText(('POINT (10 20)'), (4326))), (\"the_geom\"))",
                 builder.toString()
         );
-        builder.getConfig().set(Config.geometry_type_support, GeometrySupportType.WKB);
+        builder.geometry_support_type(GeometrySupportType.WKB);
         System.out.println(builder.toString());
         assertEquals(
                 "ST_Intersects((ST_GeomFromWKB((DECODE('000000000140240000000000004034000000000000','hex')), (4326))), (\"the_geom\"))",
@@ -154,14 +115,214 @@
         );
         assertEquals(
                 "[the_geom]",
-                ArrayUtils.toString(getVariableNames(builder))
+                ArrayUtils.toString(builder.variables_names())
         );
         assertEquals(
                 "[]",
-                ArrayUtils.toString(getParameterNames(builder))
+                ArrayUtils.toString(builder.parameters_names())
         );
     }
     
+    public void testParameter() throws CreateGeometryException {
+        ExpressionBuilder builder = new DefaultExpressionBuilder();
+                
+        GeometryManager geometryManager = GeometryLocator.getGeometryManager();
+        IProjection proj = CRSFactory.getCRS("EPSG:4326");
+        
+        Point point = geometryManager.createPoint(10, 20, Geometry.SUBTYPES.GEOM2D);
+        builder.set(        
+            builder.ST_Intersects(
+              builder.geometry(point,proj),
+              builder.parameter("the_geom")
+            )
+        );
+        builder.geometry_support_type(GeometrySupportType.WKT);
+        System.out.println(builder.toString());
+        assertEquals(
+                "ST_Intersects((ST_GeomFromText(('POINT (10 20)'), (4326))), (?))",
+                builder.toString()
+        );
+        builder.geometry_support_type(GeometrySupportType.WKB);
+        System.out.println(builder.toString());
+        assertEquals(
+                "ST_Intersects((ST_GeomFromWKB((DECODE('000000000140240000000000004034000000000000','hex')), (4326))), (?))",
+                builder.toString()
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(builder.variables_names())
+        );
+        assertEquals(
+                "[\"the_geom\"]",
+                ArrayUtils.toString(builder.parameters_names())
+        );
+    }
+    
+    public void testParameterGeomWhitoutSRS() throws CreateGeometryException {
+        ExpressionBuilder builder = new DefaultExpressionBuilder();
+                
+        GeometryManager geometryManager = GeometryLocator.getGeometryManager();
+        IProjection proj = CRSFactory.getCRS("EPSG:4326");
+        
+        Point point = geometryManager.createPoint(10, 20, Geometry.SUBTYPES.GEOM2D);
+        builder.set(        
+            builder.ST_Intersects(
+              builder.geometry(point,proj),
+              builder.parameter("the_geom").as_geometry_variable()
+            )
+        );
+        try {
+            builder.toString();
+            fail("Geometry parameter without SRS not detected.");
+        } catch(IllegalArgumentException ex) {
+            // Do nothing, it's ok that fail if not SRS is specified.
+        }
+    }
+    
+    public void testPatameterGeomWithSRS1() throws CreateGeometryException {
+        ExpressionBuilder builder = new DefaultExpressionBuilder();
+                
+        GeometryManager geometryManager = GeometryLocator.getGeometryManager();
+        IProjection proj = CRSFactory.getCRS("EPSG:4326");
+        
+        Point point = geometryManager.createPoint(10, 20, Geometry.SUBTYPES.GEOM2D);
+        builder.set(        
+            builder.ST_Intersects(
+              builder.geometry(point,proj),
+              builder.parameter("the_geom").srs(proj)
+            )
+        );
+        builder.geometry_support_type(GeometrySupportType.WKT);
+        System.out.println(builder.toString());
+        assertEquals(
+                "ST_Intersects((ST_GeomFromText(('POINT (10 20)'), (4326))), (ST_GeomFromText((?), (4326))))",
+                builder.toString()
+        );
+        builder.geometry_support_type(GeometrySupportType.WKB);
+        System.out.println(builder.toString());
+        assertEquals(
+                "ST_Intersects((ST_GeomFromWKB((DECODE('000000000140240000000000004034000000000000','hex')), (4326))), (ST_GeomFromWKB((?), (4326))))",
+                builder.toString()
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(builder.variables_names())
+        );
+        assertEquals(
+                "[\"the_geom\"]",
+                ArrayUtils.toString(builder.parameters_names())
+        );
+    }
+    
+    public void testParameterGeomWithSRS2() throws CreateGeometryException {
+        ExpressionBuilder builder = new DefaultExpressionBuilder();
+                
+        GeometryManager geometryManager = GeometryLocator.getGeometryManager();
+        IProjection proj = CRSFactory.getCRS("EPSG:4326");
+        
+        Point point = geometryManager.createPoint(10, 20, Geometry.SUBTYPES.GEOM2D);
+        builder.set(        
+            builder.ST_Intersects(
+              builder.geometry(point,proj),
+              builder.parameter("the_geom").srs(builder.constant(4326))
+            )
+        );
+        builder.geometry_support_type(GeometrySupportType.WKT);
+        System.out.println(builder.toString());
+        assertEquals(
+                "ST_Intersects((ST_GeomFromText(('POINT (10 20)'), (4326))), (ST_GeomFromText((?), (4326))))",
+                builder.toString()
+        );
+        builder.geometry_support_type(GeometrySupportType.WKB);
+        System.out.println(builder.toString());
+        assertEquals(
+                "ST_Intersects((ST_GeomFromWKB((DECODE('000000000140240000000000004034000000000000','hex')), (4326))), (ST_GeomFromWKB((?), (4326))))",
+                builder.toString()
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(builder.variables_names())
+        );
+        assertEquals(
+                "[\"the_geom\"]",
+                ArrayUtils.toString(builder.parameters_names())
+        );
+    }
+    
+    public void testParameterGeomWithParameterSRS() throws CreateGeometryException {
+        ExpressionBuilder builder = new DefaultExpressionBuilder();
+                
+        GeometryManager geometryManager = GeometryLocator.getGeometryManager();
+        IProjection proj = CRSFactory.getCRS("EPSG:4326");
+        
+        Point point = geometryManager.createPoint(10, 20, Geometry.SUBTYPES.GEOM2D);
+        builder.set(        
+            builder.ST_Intersects(
+              builder.geometry(point,proj),
+              builder.parameter("the_geom").srs(
+                      builder.parameter().value(proj)
+              )
+            )
+        );
+        builder.geometry_support_type(GeometrySupportType.WKT);
+        System.out.println(builder.toString());
+        assertEquals(
+                "ST_Intersects((ST_GeomFromText(('POINT (10 20)'), (4326))), (ST_GeomFromText((?), (?))))",
+                builder.toString()
+        );
+        builder.geometry_support_type(GeometrySupportType.WKB);
+        System.out.println(builder.toString());
+        assertEquals(
+                "ST_Intersects((ST_GeomFromWKB((DECODE('000000000140240000000000004034000000000000','hex')), (4326))), (ST_GeomFromWKB((?), (?))))",
+                builder.toString()
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(builder.variables_names())
+        );
+        assertEquals(
+                "[\"the_geom\", 4326]",
+                ArrayUtils.toString(builder.parameters_names())
+        );
+    }
+    
+    public void testParameterGeomConstant() throws CreateGeometryException {
+        ExpressionBuilder builder = new DefaultExpressionBuilder();
+                
+        GeometryManager geometryManager = GeometryLocator.getGeometryManager();
+        IProjection proj = CRSFactory.getCRS("EPSG:4326");
+        
+        Point point = geometryManager.createPoint(10, 20, Geometry.SUBTYPES.GEOM2D);
+        Point point2 = geometryManager.createPoint(10, 20, Geometry.SUBTYPES.GEOM2D);
+        point2.setProjection(proj);
+        builder.set(        
+            builder.ST_Intersects(
+              builder.geometry(point,proj),
+              builder.parameter().value(point2)
+            )
+        );
+        builder.geometry_support_type(GeometrySupportType.WKT);
+        System.out.println(builder.toString());
+        assertEquals(
+                "ST_Intersects((ST_GeomFromText(('POINT (10 20)'), (4326))), (ST_GeomFromText((?), (?))))",
+                builder.toString()
+        );
+        builder.geometry_support_type(GeometrySupportType.WKB);
+        System.out.println(builder.toString());
+        assertEquals(
+                "ST_Intersects((ST_GeomFromWKB((DECODE('000000000140240000000000004034000000000000','hex')), (4326))), (ST_GeomFromWKB((?), (?))))",
+                builder.toString()
+        );
+        assertEquals(
+                "[]",
+                ArrayUtils.toString(builder.variables_names())
+        );
+        assertEquals(
+                "[0x000000000140240000000000004034000000000000, 4326]",
+                ArrayUtils.toString(builder.parameters_names())
+        );
+    }
+    
     public void test4() throws CreateGeometryException {
         ExpressionBuilder builder = new DefaultExpressionBuilder();
                 
@@ -186,11 +347,11 @@
         );
         assertEquals(
                 "[geom1]",
-                ArrayUtils.toString(getVariableNames(builder))
+                ArrayUtils.toString(builder.variables_names())
         );
         assertEquals(
                 "[\"geom2\", 4326]",
-                ArrayUtils.toString(getParameterNames(builder))
+                ArrayUtils.toString(builder.parameters_names())
         );
     }
         
@@ -213,11 +374,11 @@
         );
         assertEquals(
                 "[geom]",
-                ArrayUtils.toString(getVariableNames(builder))
+                ArrayUtils.toString(builder.variables_names())
         );
         assertEquals(
                 "[]",
-                ArrayUtils.toString(getParameterNames(builder))
+                ArrayUtils.toString(builder.parameters_names())
         );
     }
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/operator/AddOperator.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/operator/AddOperator.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/operator/AddOperator.java	(revision 44198)
@@ -61,8 +61,8 @@
 
     @Override
     public Code optimize(Optimizer optimizer, Caller caller) {
-        Code op1 = optimizer.optimize(caller.args().get(0));
-        Code op2 = optimizer.optimize(caller.args().get(1));
+        Code op1 = optimizer.optimize(caller.parameters().get(0));
+        Code op2 = optimizer.optimize(caller.parameters().get(1));
         
         if ( op1.code() == Code.CONSTANT && op2.code() == Code.CONSTANT) {
             Code newCode = optimizer.getCodeBuilder().constant(
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/operator/MulOperator.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/operator/MulOperator.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/operator/MulOperator.java	(revision 44198)
@@ -45,8 +45,8 @@
 
     @Override
     public Code optimize(Optimizer optimizer, Code.Caller caller) {
-        Code op1 = optimizer.optimize(caller.args().get(0));
-        Code op2 = optimizer.optimize(caller.args().get(1));
+        Code op1 = optimizer.optimize(caller.parameters().get(0));
+        Code op2 = optimizer.optimize(caller.parameters().get(1));
         
         if ( op1.code() == Code.CONSTANT && op2.code() == Code.CONSTANT) {
             Code newCode = optimizer.getCodeBuilder().constant(
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/operator/SubstOperator.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/operator/SubstOperator.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/operator/SubstOperator.java	(revision 44198)
@@ -45,8 +45,8 @@
     
     @Override
     public Code optimize(Optimizer optimizer, Code.Caller caller) {
-        Code op1 = optimizer.optimize(caller.args().get(0));
-        Code op2 = optimizer.optimize(caller.args().get(1));
+        Code op1 = optimizer.optimize(caller.parameters().get(0));
+        Code op2 = optimizer.optimize(caller.parameters().get(1));
         
         if ( op1.code() == Code.CONSTANT && op2.code() == Code.CONSTANT) {
             Code newCode = optimizer.getCodeBuilder().constant(
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/operator/ConcatOperator.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/operator/ConcatOperator.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/operator/ConcatOperator.java	(revision 44198)
@@ -33,8 +33,8 @@
 
     @Override
     public Code optimize(Optimizer optimizer, Caller caller) {
-        Code op1 = optimizer.optimize(caller.args().get(0));
-        Code op2 = optimizer.optimize(caller.args().get(1));
+        Code op1 = optimizer.optimize(caller.parameters().get(0));
+        Code op2 = optimizer.optimize(caller.parameters().get(1));
         
         if ( op1.code() == Code.CONSTANT && op2.code() == Code.CONSTANT) {
             Code newCode = optimizer.getCodeBuilder().constant(
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/operator/DivOperator.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/operator/DivOperator.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/function/operator/DivOperator.java	(revision 44198)
@@ -45,8 +45,8 @@
 
     @Override
     public Code optimize(Optimizer optimizer, Code.Caller caller) {
-        Code op1 = optimizer.optimize(caller.args().get(0));
-        Code op2 = optimizer.optimize(caller.args().get(1));
+        Code op1 = optimizer.optimize(caller.parameters().get(0));
+        Code op2 = optimizer.optimize(caller.parameters().get(1));
         
         if ( op1.code() == Code.CONSTANT && op2.code() == Code.CONSTANT) {
             Code newCode = optimizer.getCodeBuilder().constant(
